#include <iostream>
using namespace std;

// O(n * log(Tmax))

int n, M, t[1001];

bool Ok(int T)
{
    long long ob = 0;
    for (int i = 1; i <= n; i++)
        ob += T / t[i];
    return ob >= M;
}

int Cb() // O(n * log2(1 
{
    int st = 1, dr = (1 << 30), mij, tmin = 1;
    while (st <= dr)
    {
        mij = st + (dr - st) / 2;  // (st + dr) / 2
        if (Ok(mij))
        {
			tmin = mij;
			dr = mij - 1;
		}
        else
			st = mij + 1;
    }
    return tmin;
}

int main()
{
    cin >> n >> M;
    for (int i = 1; i <= n; ++i)
		cin >> t[i];

    cout << Cb();

    return 0;
}
