#include <iostream>

class Fiinta {
public:
    virtual void SeHraneste()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
};

// Relatia care se modeleaza la mostenire: "IS A"
class Om : public Fiinta {
public:
    void SeHraneste() override
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Animal : public Fiinta {
public:
    void SeHraneste()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
};
int main()
{
    Fiinta* ptr = new Fiinta();
    ptr->SeHraneste();
    delete ptr;

    // Dynamic Binding (Late Binding) - Legare Dinamica
    // Decizia se ia run-time
    ptr = new Om();
    ptr->SeHraneste();
    delete ptr;

    ptr = new Animal{};
    ptr->SeHraneste();
    delete ptr;
}
