#include <stdio.h>
#include <algorithm>
#include <cstring>
#include <cassert>

using namespace std;

#define MAXN 200100

char S[100];
int A[MAXN];
int N, K;

inline bool Check(int L)
{
	int Last = -2000000000;
	int Nr = 0; // nr de segmente utilizate

	for (int i = 1; i <= N; ++i)
	{
		if (A[i] <= Last) // A[i] e acoperit de ultimul segment
			continue;

		Last = A[i] + L;
		++Nr;
		if (Nr > K)
			return false; // daca nu ajung segementele
	}

	return true;
}

int main()
{
	freopen("2d.in","r",stdin); // cin
	freopen("2d.out","w",stdout); // cout

	//FILE* fin = fopen("2d.in", "r");
	//FILE* fout = fopen("2d.out", "w");
	//fscanf(fin, "%d %d", &N, &K)
	scanf("%d %d\n", &N, &K); // fin >> N >> K;

	for (int i = 1; i <= N; ++i)
	{
		double aux1, aux2;
		scanf("%lf %lf", &aux1, &aux2); // fin >> aux1 >> aux2
		A[i] = aux1 * 1000;
	}

	sort(A + 1, A + N + 1);

	int Mid, Left = 1000, Right = 2000000000, Lmin = 1000;

	while (Left <= Right)
	{
		Mid = (Left + Right) / 2;
		if (Check(Mid))  // propunem o lungime L = Mid pentru segmente
		{
			Lmin = Mid;
			Right = Mid - 1;
		}
		else
			Left = Mid + 1;
	}

	printf("%d.%.3d\n", Lmin / 1000, Lmin % 1000);
//	fout << Lmin \ 100 << "." << Lmin % 1000;

	return 0;
}
